package com.mygdx.game.level;

import com.badlogic.gdx.files.FileHandle;
import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author Martin
 */
public class Level {

	public static final int EMPTY_TYPE = 0;
	public static final int GRASS_TYPE = 1;
	private String name;
	private int[][] tiles;

	public Level(String name) {
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public int[][] getTiles() {
		return tiles;
	}

	public void setTiles(int[][] tiles) {
		this.tiles = tiles;
	}

	public static Level loadFromFile(FileHandle levelFile) throws IOException {
		Level level = new Level(levelFile.nameWithoutExtension());
		List<String> lines = new ArrayList<>();
		try (BufferedReader reader = new BufferedReader(levelFile.reader())) {
			String line;
			while ((line = reader.readLine()) != null) {
				lines.add(line);
			}
		}
		Collections.reverse(lines);

		for (int i = 0; i < lines.size(); i++) {
			String[] cols = lines.get(i).split(" ");
			if (level.tiles == null) {
				level.tiles = new int[lines.size()][cols.length];
			}
			
			for (int j = 0; j < cols.length; j++) {
				int tileType = Integer.parseInt(cols[j]);
				level.tiles[i][j] = tileType;
			}
		}

		return level;
	}
}
